package me.flashyreese.mods.sodiumextra.mixin.sodium.fast_random;

import me.flashyreese.mods.sodiumextra.client.SodiumExtraClientMod;
import me.jellysquid.mods.sodium.client.model.light.LightPipelineProvider;
import me.jellysquid.mods.sodium.client.model.quad.blender.ColorBlender;
import me.jellysquid.mods.sodium.client.render.pipeline.BlockRenderer;
import net.minecraft.class_310;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Mutable;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.Random;

@Mixin(value = BlockRenderer.class, remap = false)
public class MixinBlockRenderer {
    @Shadow
    @Final
    @Mutable
    private Random random;

    @Inject(method = "<init>", at = @At(value = "TAIL"))
    private void init(class_310 client, LightPipelineProvider lighters, ColorBlender colorBlender, CallbackInfo ci) {
        if (!SodiumExtraClientMod.options().extraSettings.useFastRandom) {
            this.random = new Random();
        }
    }
}
